/******************************************************************************** 
Desarrollado por:   Globant de México
Autor:              Roberto Carlos Avendaño Quintana
Proyecto:           TOYOTA TAM
Descripción:        Clase que contiene la logica para crear el estado de cuenta a partir de la provisión de incentivos
******************************************************************************* */
global class TAM_ScheduledSolicitudIncentivos Implements Schedulable
{
    global void execute(SchedulableContext sc)  
    {
        //Metodo que genera el estado de cuenta a partir de las solicitudes de bono aprobadas y que el VIN se encuentre en BDD de Dealer Daily
        generaEstadoCuentaBono();
        //Metodo que genera el estado de cuenta de Retail
        generaEstadoCuentaRetail();
        //Metodo que genera el estado de cuenta excepciónes de VC
        generaEdoCtaVentaCorp();  
    }  
    
    public void generaEstadoCuentaBono (){ 
        List<TAM_SolicitudDeBono__c> listaBonos = new List<TAM_SolicitudDeBono__c>();
        Map<String,TAM_EstadoCuenta__c> mapSolicitudBono = new Map<String,TAM_EstadoCuenta__c>();
        Map<String,Movimiento__c> mapInformacionVIN = new Map<String,Movimiento__c> ();
        Set<String> VINSolicitud = new Set<String>();
        Set<String> codigoDealer = new Set<String>();
        List<Date> fechaVenta = new List<Date>();
        List<TAM_DetalleEstadoCuenta__c> detalleEdoCta = new List<TAM_DetalleEstadoCuenta__c>();
        List<Movimiento__c> listaMovimientos = new List<Movimiento__c> ();
        String recordIdBono = Schema.SObjectType.TAM_DetalleEstadoCuenta__c.getRecordTypeInfosByDeveloperName().get('Bono').getRecordTypeId();
        TAM_EstadoCuenta__c estadoCuenta = new TAM_EstadoCuenta__c (); 
        Movimiento__c  detalleVIN        = new Movimiento__c ();


        decimal diasVigencia = [Select TAM_DiasVigencia__c From TAM_DetalleEdoCta__c Limit 1].TAM_DiasVigencia__c;
        Integer diasVigenciaInt = diasVigencia.intValue();
        
        
        listaBonos = [SELECT Id,createdDate,TAM_BonoSeleccionado__r.TAM_BonoTMEXEfectivo__c,TAM_Distribuidor__r.TAM_Gestor_Estado_Cuenta__c,TAM_TipoMovimiento__c,
                      TAM_Distribuidor__r.Codigo_Distribuidor__c,Name,OwnerId,TAM_AnioModelo__c,TAM_AprobacionFinanzas__c,TAM_AprobacionVentas__c,TAM_BonoCorrespondiente__c,
                      TAM_BonoElejido__c,TAM_BonoSeleccionado__c,TAM_CodigoDealer__c,TAM_CodigoModelo__c,TAM_CodigoVenta__c,TAM_ComentarioDealer__c,TAM_ComentarioFinanzas__c,
                      TAM_ComentarioVentas__c,TAM_CumpleConCondiciones__c,TAM_Distribuidor__c,TAM_EstatusSolicitudBono__c,TAM_EstatusVIN__c,TAM_ExisteEdoCta__c,TAM_FechaVenta__c,
                      TAM_Fecha_Autorizacion_DM__c,TAM_Fecha_Autorizacion_Finanzas__c,TAM_NombreDealer__c,TAM_Nombre_DM__c,TAM_ParteTMEXSinIva__c,TAM_Serie__c,TAM_VIN__c 
                      FROM TAM_SolicitudDeBono__c  WHERE TAM_ExisteEdoCta__c = false];
        
        if(!listaBonos.isEmpty()){
            for(TAM_SolicitudDeBono__c vinesSolicitud : listaBonos){
                if(vinesSolicitud.TAM_ExisteEdoCta__c == false  &&  vinesSolicitud.TAM_AprobacionFinanzas__c == 'Aprobado'){
                    VINSolicitud.add(vinesSolicitud.TAM_VIN__c);
                    codigoDealer.add(vinesSolicitud.TAM_Distribuidor__r.Codigo_Distribuidor__c);
                    fechaVenta.add(vinesSolicitud.TAM_Fecha_Autorizacion_Finanzas__c);
                    
                }
            } 
        } 
        
        if(!VINSolicitud.isEmpty()){
            listaMovimientos = [Select id,Submitted_Date__c,name,TAM_Serie__c,TAM_VIN__c,Last_Name__c,NombreCliente__c,Sale_Date__c,
                                Trans_Type__c   From Movimiento__c WHERE TAM_VIN__c IN : VINSolicitud AND 
                                VIN__r.Ultimo_Movimiento__r.Trans_Type__c = 'RDR'
                               ];  
        } 
        
        
        if(!listaMovimientos.isEmpty()){
            for(Movimiento__c mov : listaMovimientos){
                mapInformacionVIN.put(mov.TAM_VIN__c,mov);
                //fechaVenta.add(mov.Submitted_Date__c.date());
            }   
        }
        
        //Calcular fecha para estado de cuenta en base a la fecha de venta
        List<String>listaFechas = obtieneFechaTextoList(fechaVenta);
        
        
         //Se consultan los estados de cuenta por dealer que se encuentren abiertos ordenados por fecha
        List<TAM_EstadoCuenta__c> edoCtasDealer = new List<TAM_EstadoCuenta__c>();
        
        Map<String, List<TAM_EstadoCuenta__c>> mapDealerEdoCta = new Map<String, List<TAM_EstadoCuenta__c>>();
        
        
        for(TAM_EstadoCuenta__c edoCtaReg : [Select id,TAM_CodigoDealer__c,TAM_FechaInicio__c From TAM_EstadoCuenta__c
                                             WHERE TAM_CodigoDealer__c IN : codigoDealer and TAM_EstadoRegistro__c = 'Abierto'
                                             and TAM_FechaInicio__c != null
                                             order by TAM_FechaInicio__c desc]){
                                                 
                                                 if(!mapDealerEdoCta.containsKey(edoCtaReg.TAM_CodigoDealer__c)){    
                                                     mapDealerEdoCta.put(edoCtaReg.TAM_CodigoDealer__c, new TAM_EstadoCuenta__c[]{});
                                                 }
                                                 mapDealerEdoCta.get(edoCtaReg.TAM_CodigoDealer__c).add(edoCtaReg);
                                                 
                                             }
        
        
        
        system.debug('Mpa edo ctass'+mapDealerEdoCta);
        
        
        
        
        //SE CREA EL ESTADO DE CUENTA A PARTIR DE LA FECHA DE VENTA  
        List<TAM_EstadoCuenta__c> listadealerEstadoCuenta = new List<TAM_EstadoCuenta__c> ();
        Map<Id, TAM_EstadoCuenta__c> mapEstadoCta = new Map<Id, TAM_EstadoCuenta__c>();
        Set<TAM_EstadoCuenta__c> edoCtaSet = new Set<TAM_EstadoCuenta__c>();
        map<String,TAM_EstadoCuenta__c> edoCtaMap = new map<String,TAM_EstadoCuenta__c>();
        if(!listaBonos.isEmpty()){
            for(TAM_SolicitudDeBono__c inSol : listaBonos){
                if(mapInformacionVIN.containsKey(inSol.TAM_VIN__c)){
                    detalleVIN  = mapInformacionVIN.get(inSol.TAM_VIN__c);
                    List<TAM_EstadoCuenta__c> edoCtaByDealer = mapDealerEdoCta.get(inSol.TAM_CodigoDealer__c);
                	//Si fecha de reporte es mayor al ultimo estado de cuenta liberado --> la exepción se va al estado de cuenta del mes 
                	String fechaEdoCta;
                	system.debug('edo cta seleccionado'+edoCtaByDealer[0].TAM_FechaInicio__c);
                	if(inSol.TAM_FechaVenta__c > edoCtaByDealer[0].TAM_FechaInicio__c){
                    	fechaEdoCta = obtieneFechaTexto(inSol.TAM_FechaVenta__c);
                	}
                
                
                	//Si fecha de reporte es menor al último estado de cuenta liberado--> la excepción se va al último estado de cuenta liberado
                	if(inSol.TAM_FechaVenta__c <= edoCtaByDealer[0].TAM_FechaInicio__c){
                    	fechaEdoCta = obtieneFechaTexto(edoCtaByDealer[0].TAM_FechaInicio__c);
                	}

                
                    TAM_EstadoCuenta__c dealerEstadoCuenta = new TAM_EstadoCuenta__c();
                    dealerEstadoCuenta.TAM_CodigoDealer__c = inSol.TAM_CodigoDealer__c;
                    dealerEstadoCuenta.TAM_NombreDealer__c = inSol.TAM_NombreDealer__c;
                    dealerEstadoCuenta.TAM_FechaEstadoCuenta__c = fechaEdoCta;
                    dealerEstadoCuenta.Name = inSol.TAM_CodigoDealer__c+'-'+fechaEdoCta;                
                    dealerEstadoCuenta.Id_Externo__c      = inSol.TAM_CodigoDealer__c+'-'+fechaEdoCta;
                    if(inSol.TAM_Distribuidor__r.TAM_Gestor_Estado_Cuenta__c != null){
                        dealerEstadoCuenta.ownerId = inSol.TAM_Distribuidor__r.TAM_Gestor_Estado_Cuenta__c;
                    }
                    edoCtaSet.add(dealerEstadoCuenta);
                    edoCtaMap.put(inSol.TAM_CodigoDealer__c+'-'+fechaEdoCta,dealerEstadoCuenta);
                }
            }
        }
        
        //Si la lista es diferente de vacia se insertan los registros
        if(!edoCtaMap.isEmpty()){
            Schema.SObjectField idExterno = TAM_EstadoCuenta__c.Fields.Id_Externo__c;
            try{
                Database.UpsertResult [] cr = Database.upsert(edoCtaMap.values(),idExterno, false);  
                for (Database.UpsertResult objDtSvr : cr){
                    if(!objDtSvr.isSuccess())
                        System.debug('Regitros edos de cuenta con errores Bono ' + objDtSvr.getErrors()[0].getMessage());
                    
                    if(objDtSvr.isSuccess())
                        System.debug('Regitros edos de cuenta insertados Bono' + objDtSvr.id);
                    
                } 
            }catch(Exception e){
                system.debug('Error en upsert de la lista listadealer EstadoCuenta'+e.getMessage());  
            } 
        } 
        
        
        
        Map<String,TAM_EstadoCuenta__c> mapaEdoCtas = new  Map<String,TAM_EstadoCuenta__c>(); 
        
        for(String mapValue : edoCtaMap.keySet()){
            mapaEdoCtas.put(mapValue,edoCtaMap.get(mapValue));
            
        }
        
        //Se crean las lineas del estado de cuenta de tipo "Bono"
        map<String,TAM_DetalleEstadoCuenta__c> edoDetalleEdoCta = new map<String,TAM_DetalleEstadoCuenta__c>();        
        if(!listaBonos.isEmpty()){ 
            for(TAM_SolicitudDeBono__c solBono : listaBonos){
                if(solBono.TAM_EstatusVIN__c == 'VIN en Dealer Daily' &&  solBono.TAM_AprobacionFinanzas__c == 'Aprobado'){
                    if(mapInformacionVIN.containsKey(solBono.TAM_VIN__c)){
                        detalleVIN  = mapInformacionVIN.get(solBono.TAM_VIN__c);
                        List<TAM_EstadoCuenta__c> edoCtaByDealer = mapDealerEdoCta.get(solBono.TAM_CodigoDealer__c);
                    	//Si la fecha de reporte es mayor
                    	String periodoVenta;
                    	if(solBono.TAM_FechaVenta__c > edoCtaByDealer[0].TAM_FechaInicio__c){
                        	periodoVenta = obtieneFechaTexto(solBono.TAM_FechaVenta__c);
                    	}
                    
                    	//Si la fecha de reporte es menor
                    	if(solBono.TAM_FechaVenta__c <= edoCtaByDealer[0].TAM_FechaInicio__c){
                        	periodoVenta = obtieneFechaTexto(edoCtaByDealer[0].TAM_FechaInicio__c);
                    	}
                        
                        if(mapaEdoCtas.containsKey(solBono.TAM_CodigoDealer__c+'-'+periodoVenta) && mapInformacionVIN.containsKey(solBono.TAM_VIN__c)){
                            estadoCuenta = mapaEdoCtas.get(solBono.TAM_CodigoDealer__c+'-'+periodoVenta);
                            detalleVIN = mapInformacionVIN.get(solBono.TAM_VIN__c);
                            TAM_DetalleEstadoCuenta__c lineaDetalle = new TAM_DetalleEstadoCuenta__c();
                            lineaDetalle.TAM_SolcitudBono__c = solBono.id;
                            lineaDetalle.TAM_FechaCaducidad__c = date.today()+diasVigenciaInt;
                            lineaDetalle.TAM_CodigoDealer__c = solBono.TAM_CodigoDealer__c;
                            lineaDetalle.TAM_NombreDealer__c = solBono.TAM_NombreDealer__c;
                            lineaDetalle.TAM_VIN__c    =  solBono.TAM_VIN__c;
                            lineaDetalle.TAM_Serie__c  =  detalleVIN.TAM_Serie__c;
                            lineaDetalle.TAM_Codigo_Producto__c = solBono.TAM_CodigoModelo__c;
                            lineaDetalle.TAM_AnioModelo__c     = solBono.TAM_AnioModelo__c;
                            lineaDetalle.TAM_EstadoCuenta__c   = estadoCuenta.Id;
                            lineaDetalle.RecordTypeId = recordIdBono;
                            if(solBono.TAM_TipoMovimiento__c == 'Sin Excepción'){
                                lineaDetalle.TAM_Movimiento__c = detalleVIN.Trans_Type__c;   
                            }
                            if(solBono.TAM_TipoMovimiento__c == 'Con Excepción'){
                                lineaDetalle.TAM_Movimiento__c = 'Excepción';   
                            }
                            if(solBono.TAM_Fecha_Autorizacion_Finanzas__c != null){
                                lineaDetalle.TAM_Fecha_Aprobacion_Final__c = solBono.TAM_Fecha_Autorizacion_Finanzas__c;
                            }
                            if(solBono.TAM_Fecha_Autorizacion_Finanzas__c == null){
                                lineaDetalle.TAM_Fecha_Aprobacion_Final__c = solBono.createdDate.date();
                            }
                            
                            lineaDetalle.TAM_FechaVenta__c = solBono.TAM_FechaVenta__c;
                            lineaDetalle.TAM_NombrePropietario__c = detalleVIN.NombreCliente__c;
                            lineaDetalle.TAM_ApellidosPropietario__c = detalleVIN.Last_Name__c;
                            lineaDetalle.TAM_IncentivoPropuestoDealer__c = solBono.TAM_BonoSeleccionado__r.TAM_BonoTMEXEfectivo__c;
                            lineaDetalle.TAM_Monto_sin_IVA__c = solBono.TAM_BonoSeleccionado__r.TAM_BonoTMEXEfectivo__c;
                            lineaDetalle.TAM_IntercambioEdoCta__c = false;
                            lineaDetalle.TAM_IDExterno__c = estadoCuenta.Id+detalleVIN.TAM_VIN__c+recordIdBono;
                            lineaDetalle.TAM_Estatus_Finanzas__c = 'Pendiente';        
                            if(solBono.TAM_FechaVenta__c != null){
                                lineaDetalle.TAM_Anio_Incentivo__c = String.valueOf(solBono.TAM_FechaVenta__c.year());
                                lineaDetalle.TAM_Periodo__c = obtieneMesPeriodo(solBono.TAM_FechaVenta__c.month());
                            }
                            
                            detalleEdoCta.add(lineaDetalle);
                            
                        }
                    }
                }
            }
        }
        
        if(!detalleEdoCta.isEmpty()){
            Schema.SObjectField idExterno = TAM_DetalleEstadoCuenta__c.Fields.TAM_IDExterno__c;
            try{
                List<Database.UpsertResult> lcr = Database.upsert(detalleEdoCta,idExterno, false);
                Set<String> registrosInsertados = new Set<String>();
                for (Database.UpsertResult objDtSvr : lcr){
                    if(objDtSvr.isSuccess())  
                        system.debug('Id Registros insertados de Bono'+objDtSvr.id);
                    registrosInsertados.add(objDtSvr.id);
                    if(!objDtSvr.isSuccess())
                        System.debug('Registros con error de Bono:' + objDtSvr.getErrors()[0].getMessage());
                }      
                actualizaFlagBono(registrosInsertados);
            }catch(Exception e){
                system.debug('Error general al momento de	 insertar los registros de estado de cuenta de bono'+ e.getMessage());
            }
        } 
    }
    
    //Se actualiza la bandera a nivel solicitud de excepción para indicar que ya fue creada en un estado de cuenta y no se puede volver a crear
    public static void actualizaFlagBono(Set<String>listDetallesCreados){
        Set<String> listaVINES = new Set<String>();
        List<TAM_DetalleEstadoCuenta__c> detalleEdoCta  = new  List<TAM_DetalleEstadoCuenta__c> ();
        List<TAM_SolicitudDeBono__c> solicitudesBono  = new List<TAM_SolicitudDeBono__c>();
        List<TAM_SolicitudDeBono__c> solicitudesBonoUpd  = new List<TAM_SolicitudDeBono__c>();
        if(!listDetallesCreados.isEmpty()){
            detalleEdoCta = [Select id,TAM_VIN__C From TAM_DetalleEstadoCuenta__c WHERE ID IN: listDetallesCreados];
            
        }
        
        Map<String,TAM_DetalleEstadoCuenta__c> VINDetalle = new Map<String,TAM_DetalleEstadoCuenta__c>();
        if(!detalleEdoCta.isEmpty()){
            for(TAM_DetalleEstadoCuenta__c detalle : detalleEdoCta){
                listaVINES.add(detalle.TAM_VIN__C);
                VINDetalle.put(detalle.TAM_VIN__C,detalle);
                
            }
            
        }
        
        if(!listaVINES.isEmpty()){
            solicitudesBono = [select id,TAM_VIN__c,TAM_ExisteEdoCta__c  FROM TAM_SolicitudDeBono__c WHERE 
                               TAM_VIN__c IN:listaVINES  AND TAM_AprobacionFinanzas__c = 'Aprobado'
                               AND TAM_ExisteEdoCta__c = false];
            
        }
        
        if(!solicitudesBono.isEmpty()){
            for(TAM_SolicitudDeBono__c inSol : solicitudesBono){
                if(VINDetalle.containsKey(inSol.TAM_VIN__c)){
                    TAM_DetalleEstadoCuenta__c detalleEdo = VINDetalle.get(inSol.TAM_VIN__c);
                	TAM_SolicitudDeBono__c newItem = new TAM_SolicitudDeBono__c();
                    newItem.TAM_DetalleEstadoCuenta__c = detalleEdo.Id;
                	newItem.id = inSol.id;
                	newItem.TAM_ExisteEdoCta__c = true;
                	solicitudesBonoUpd.add(newItem);
                }
            }
            
        }
        
        if(!solicitudesBonoUpd.isEmpty()){       
            update solicitudesBonoUpd;
        }
    }
    
    
    public void generaEstadoCuentaRetail(){
        List<TAM_SolicitudExpecionIncentivo__c> listExcepciones = new List<TAM_SolicitudExpecionIncentivo__c>();
        Map<String,TAM_EstadoCuenta__c> mapaEdoCtas = new  Map<String,TAM_EstadoCuenta__c>(); 
        Map<String,Movimiento__c> mapInformacionVIN = new Map<String,Movimiento__c> ();
        Set<String> vinSolicitud = new   Set<String> ();
        Set<String> codigoDealer = new Set<String>();
        list<TAM_EstadoCuenta__c> listadealerEstadoCuenta = new  list<TAM_EstadoCuenta__c>();
        List<Date> fechaVenta = new List<Date>();
        List<TAM_DetalleEstadoCuenta__c> lineaEdoCta = new  List<TAM_DetalleEstadoCuenta__c>();
        List<Movimiento__C> movVIN = new List<Movimiento__c>();
        List<TAM_EstadoCuenta__c> edoCtaLista = new List<TAM_EstadoCuenta__c>();
        List<TAM_DetalleEstadoCuenta__c> detalleEdoCta = new List<TAM_DetalleEstadoCuenta__c>();
        TAM_EstadoCuenta__c estadoCuenta = new TAM_EstadoCuenta__c (); 
        Movimiento__c  detalleVIN        = new Movimiento__c (); 
        String edoCta;

        decimal diasVigencia = [Select TAM_DiasVigencia__c From TAM_DetalleEdoCta__c Limit 1].TAM_DiasVigencia__c;
        Integer diasVigenciaInt = diasVigencia.intValue();
        
        String recordIdRetail;
        String recordIdAutoDemo;
        String recordIdSolicitudRetail = Schema.SObjectType.TAM_SolicitudExpecionIncentivo__c.getRecordTypeInfosByDeveloperName().get('Cambio_de_Incentivo').getRecordTypeId();
        String recordIdSolicitudAutoDemo = Schema.SObjectType.TAM_SolicitudExpecionIncentivo__c.getRecordTypeInfosByDeveloperName().get('Auto_Demo').getRecordTypeId();
        String recordIdSolicitudVC = Schema.SObjectType.TAM_SolicitudExpecionIncentivo__c.getRecordTypeInfosByDeveloperName().get('ExcepcionVentaCorporativa').getRecordTypeId();
        
        listExcepciones = [SELECT TAM_SolicitudExpecionIncentivo__c.TAM_SubmittedDate__c,TAM_TotalIncentivoDealerManual__c,TAM_TotalIncentivoManual__c,
                           TAM_TotalIncentivoTMEXManual__c,TAM_SolicitudExpecionIncentivo__c.TAM_RangoPrograma__c,TAM_excepcionFlotillaRetail__c,TAM_Distribuidor__r.TAM_Gestor_Estado_Cuenta__c,Email_DM__c,Id,Incentivo_Correspondiente_TMEX__c,Name,Nombre_DM__c,
                           OwnerId,RecordTypeId,TAMVIN__c,TAM_AnioModelo__c,TAM_AprobacionDM__c,TAM_AprobacionFinanzas__c,TAM_CodigoDealer__c,TAM_ComentarioDM__c,
                           TAM_ComentarioFinanzas__c,TAM_Comentario__c,TAM_Distribuidor__c,TAM_Email_DM__c,TAM_EstadoCuenta__c,TAM_FechaVigenciaCliente__c,
                           TAM_Fecha_Autorizacion_DM__c,TAM_Fecha_Autorizacion_Finanzas__c,TAM_FolioVentaCorporativa__c,TAM_IDExterno__c,TAM_IncCorrespCashTMEX__c,
                           TAM_IncentivoCorrespondienteFecha__c,TAM_IncentivoCorrespondienteRetail__c,TAM_IncentivoDealerPorcentaje__c,TAM_IncentivoDealer__c,
                           TAM_IncentivoManual__c,TAM_IncentivoPropuestoPorcentaje__c,TAM_IncentivoPropuesto__c,TAM_IncentivoTMEXPorcentaje__c,TAM_IncentivoTMEX__c,
                           TAM_IncSeleccCashTMEX__c,TAM_listaVINES__c,TAM_Modelo__c,TAM_MontoIncentivoTMEXManual__c,TAM_MontoIncentivoTMEXPolitica__c,TAM_MotivoCambioPrecio__c,
                           TAM_MotivoSolicitudFlotilla__c,TAM_MotivoSolicitud__c,TAM_NombreCliente__c,TAM_NombreDealer__c,TAM_NumeroVINES__c,TAM_PoliticaSeleccionadaFleet__c,
                           TAM_PoliticaSeleccionadaRetail__c,TAM_PoliticaSeleccionada__c,TAM_PorcentajeDealer__c,TAM_PorcentajeTMEX__c,TAM_PrecioSolicitadoDealer__c,TAM_PrecioVigente__c 
                           FROM TAM_SolicitudExpecionIncentivo__c 
                           WHERE (TAM_EstadoCuenta__c = false AND TAM_AprobacionFinanzas__c = 'Aprobado') AND  (recordtypeId=: recordIdSolicitudRetail OR recordtypeId =:recordIdSolicitudAutoDemo OR  (recordtypeId =: recordIdSolicitudVC AND TAM_excepcionFlotillaRetail__c = true)) limit 30];
        
        system.debug('lista excepciones VC'+listExcepciones);
        
        if(!listExcepciones.isEmpty()){
            for(TAM_SolicitudExpecionIncentivo__c inSol : listExcepciones){
                //Exepcion de Retail
                if(inSol.TAM_AprobacionFinanzas__c == 'Aprobado' && inSol.TAM_EstadoCuenta__c == false && (inSol.RecordTypeId == recordIdSolicitudRetail || inSol.RecordTypeId == recordIdSolicitudVC)){
                    recordIdRetail  = Schema.SObjectType.TAM_DetalleEstadoCuenta__c.getRecordTypeInfosByDeveloperName().get('Retail').getRecordTypeId();
                    vinSolicitud.add(inSol.TAMVIN__c);
                    codigoDealer.add(inSol.TAM_CodigoDealer__c);
                    fechaVenta.add(inSol.TAM_Fecha_Autorizacion_Finanzas__c);
                }
                // Excepcion de Auto Demo
                if(inSol.TAM_AprobacionFinanzas__c == 'Aprobado' && inSol.TAM_EstadoCuenta__c == false && inSol.RecordTypeId == recordIdSolicitudAutoDemo){
                    recordIdAutoDemo  = Schema.SObjectType.TAM_DetalleEstadoCuenta__c.getRecordTypeInfosByDeveloperName().get('AutoDemo').getRecordTypeId();
                    vinSolicitud.add(inSol.TAMVIN__c);
                    codigoDealer.add(inSol.TAM_CodigoDealer__c);
                    fechaVenta.add(inSol.TAM_Fecha_Autorizacion_Finanzas__c);
                }
                // Excepcion de Flotilla - Retail
                if(inSol.TAM_AprobacionFinanzas__c == 'Aprobado' && inSol.TAM_EstadoCuenta__c == false && inSol.RecordTypeId == recordIdSolicitudVC && inSol.TAM_excepcionFlotillaRetail__c == true){
                    system.debug('entro a execpion flotilla retail');
                    recordIdRetail  = Schema.SObjectType.TAM_DetalleEstadoCuenta__c.getRecordTypeInfosByDeveloperName().get('Retail').getRecordTypeId();
                    vinSolicitud.add(inSol.TAMVIN__c);
                    codigoDealer.add(inSol.TAM_CodigoDealer__c);
                    fechaVenta.add(inSol.TAM_Fecha_Autorizacion_Finanzas__c);
                }
                
            } 
        }
        
        if(!vinSolicitud.isEmpty()){
            system.debug('entro a lista de VIN');
            movVIN = [Select id,Submitted_Date__c,name,ProductoCode__c,Serie__c,TAM_Serie__c ,TAM_VIN__c,Last_Name__c,NombreCliente__c,Sale_Date__c,
                      Trans_Type__c,Year_Modelo__c From Movimiento__c WHERE TAM_VIN__c IN : vinSolicitud AND 
                      VIN__r.Ultimo_Movimiento__r.Trans_Type__c = 'RDR'];  
            
        }
        
        if(!movVIN.isEmpty()){
            system.debug('entro a movimientos');
            for(Movimiento__C mov : movVIN){
                fechaVenta.add(mov.Submitted_Date__c.date());
                system.debug('entro a llenar el mapa VIN');
                mapInformacionVIN.put(mov.TAM_VIN__c,mov);
            }
        }
        
        //Calcular fecha para estado de cuenta en base a la fecha de venta
        
        
        
        //Se consultan los estados de cuenta por dealer que se encuentren abiertos ordenados por fecha
        List<TAM_EstadoCuenta__c> edoCtasDealer = new List<TAM_EstadoCuenta__c>();
        
        Map<String, List<TAM_EstadoCuenta__c>> mapDealerEdoCta = new Map<String, List<TAM_EstadoCuenta__c>>();
        
        
        for(TAM_EstadoCuenta__c edoCtaReg : [Select id,TAM_FechaEstadoCuenta__c,TAM_CodigoDealer__c,TAM_FechaInicio__c From TAM_EstadoCuenta__c
                                             WHERE TAM_CodigoDealer__c IN : codigoDealer and TAM_EstadoRegistro__c = 'Abierto'
                                             and TAM_FechaInicio__c != null
                                             order by TAM_FechaInicio__c desc]){
                                                 
                                                 if(!mapDealerEdoCta.containsKey(edoCtaReg.TAM_CodigoDealer__c)){    
                                                     mapDealerEdoCta.put(edoCtaReg.TAM_CodigoDealer__c, new TAM_EstadoCuenta__c[]{});
                                                 }
                                                 mapDealerEdoCta.get(edoCtaReg.TAM_CodigoDealer__c).add(edoCtaReg);
                                                 
                                             }
        
        
        
        system.debug('Mpa edo ctass'+mapDealerEdoCta);
        
        
        
        //Se crea un estado de cuenta en base a la fecha de venta del VIN
        map<String,TAM_EstadoCuenta__c> edoCtaMap = new map<String,TAM_EstadoCuenta__c>();
        for(TAM_SolicitudExpecionIncentivo__c inSol : listExcepciones){
            if(mapInformacionVIN.containsKey(inSol.TAMVIN__c)){
                detalleVIN  = mapInformacionVIN.get(inSol.TAMVIN__c);
                List<TAM_EstadoCuenta__c> edoCtaByDealer = mapDealerEdoCta.get(inSol.TAM_CodigoDealer__c);
                //Si fecha de reporte es mayor al ultimo estado de cuenta liberado --> la exepción se va al estado de cuenta del mes 
                String fechaEdoCta;
                system.debug('edo cta seleccionado'+edoCtaByDealer[0].TAM_FechaInicio__c);
                if(inSol.TAM_SubmittedDate__c > edoCtaByDealer[0].TAM_FechaInicio__c){
                    fechaEdoCta = obtieneFechaTexto(inSol.TAM_SubmittedDate__c);
                    system.debug('linea 416 '+ fechaEdoCta);
                }
                
                
                //Si fecha de reporte es menor al último estado de cuenta liberado--> la excepción se va al último estado de cuenta liberado
                if(inSol.TAM_SubmittedDate__c <= edoCtaByDealer[0].TAM_FechaInicio__c){
                    fechaEdoCta = edoCtaByDealer[0].TAM_FechaEstadoCuenta__c;
                    system.debug('linea 423 '+ fechaEdoCta);
                }
                
                
                TAM_EstadoCuenta__c dealerEstadoCuenta = new TAM_EstadoCuenta__c();
                dealerEstadoCuenta.TAM_CodigoDealer__c = inSol.TAM_CodigoDealer__c;
                dealerEstadoCuenta.TAM_NombreDealer__c = inSol.TAM_NombreDealer__c;
                dealerEstadoCuenta.TAM_FechaEstadoCuenta__c = fechaEdoCta;
                dealerEstadoCuenta.name					= inSol.TAM_CodigoDealer__c+'-'+fechaEdoCta;
                dealerEstadoCuenta.Id_Externo__c      = inSol.TAM_CodigoDealer__c+'-'+fechaEdoCta;
                if(inSol.TAM_Distribuidor__r.TAM_Gestor_Estado_Cuenta__c != null){
                    dealerEstadoCuenta.ownerId = inSol.TAM_Distribuidor__r.TAM_Gestor_Estado_Cuenta__c;
                } 
                listadealerEstadoCuenta.add(dealerEstadoCuenta);
                edoCtaMap.put(inSol.TAM_CodigoDealer__c+'-'+fechaEdoCta,dealerEstadoCuenta);
                
            }
        }
        //Si la lista es diferente de vacia se insertan los registros
        if(!listadealerEstadoCuenta.isEmpty()){
            Schema.SObjectField idExterno = TAM_EstadoCuenta__c.Fields.Id_Externo__c;
            try{
                Database.UpsertResult [] cr = Database.upsert(edoCtaMap.values(),idExterno, false);  
                for (Database.UpsertResult objDtSvr : cr){
                    if(!objDtSvr.isSuccess())
                        System.debug('Regitros edos de cuenta con errores ' + objDtSvr.getErrors()[0].getMessage());
                    
                    if(objDtSvr.isSuccess())
                        System.debug('Regitros edos de cuenta insertados ' + objDtSvr.id);
                    
                } 
            }catch(Exception e){
                system.debug('Error en upsert de la lista listadealer EstadoCuenta'+e.getMessage());  
            } 
        } 
        
        
        
        for(String mapValue : edoCtaMap.keySet()){
            mapaEdoCtas.put(mapValue,edoCtaMap.get(mapValue));
            
            
        }
        system.debug('mapa con estados'+mapaEdoCtas);
        
        //Se obtienen detalles de estado de cuenta con los vines que se encuentran en su estado de cuenta
        List<TAM_DetalleEstadoCuenta__c> detalleEstadoCuenta = [Select id,TAM_DetalleProvision__r.TAM_CodigoDealer__c,TAM_VIN__c,TAM_IDExterno__c
                                                                From TAM_DetalleEstadoCuenta__c where TAM_EstadoCuenta__c != null AND
                                                                TAM_Estatus_Finanzas__c != 'Pago Autorizado TMEX' AND TAM_VIN__C IN : vinSolicitud];
        
        Map<String,TAM_DetalleEstadoCuenta__c> detalleVINEdoCta = new Map<String,TAM_DetalleEstadoCuenta__c> ();
        
        if(!detalleEstadoCuenta.isEmpty()){
            for(TAM_DetalleEstadoCuenta__c dVIN : detalleEstadoCuenta){
                detalleVINEdoCta.put(dVIN.TAM_VIN__c,dVIN);
                
            }
        }
        
        //Crear las lineas del estado de cuenta de tipo Excepciónes Retail o AutoDemo
        map<String,TAM_DetalleEstadoCuenta__c> edoDetalleEdoCta = new map<String,TAM_DetalleEstadoCuenta__c>();
        for(TAM_SolicitudExpecionIncentivo__c inSol : listExcepciones){
            if(inSol.TAM_AprobacionFinanzas__c == 'Aprobado' && inSol.TAM_EstadoCuenta__c == false && (inSol.recordtypeId == recordIdSolicitudRetail || inSol.recordtypeId == recordIdSolicitudAutoDemo)){
                if(mapInformacionVIN.containsKey(inSol.TAMVIN__c)){
                    detalleVIN  = mapInformacionVIN.get(inSol.TAMVIN__c);
                    List<TAM_EstadoCuenta__c> edoCtaByDealer = mapDealerEdoCta.get(inSol.TAM_CodigoDealer__c);
                    //Si la fecha de reporte es mayor se va al estado de cuenta de fecha de reporte
                    String periodoVenta;
                    if(inSol.TAM_SubmittedDate__c > edoCtaByDealer[0].TAM_FechaInicio__c){
                        periodoVenta = obtieneFechaTexto(inSol.TAM_SubmittedDate__c);
                        system.debug('linea 493'+periodoVenta);
                    }
                    
                    //Si la fecha de reporte es menor se va al último estado de cuenta liberado
                    if(inSol.TAM_SubmittedDate__c <= edoCtaByDealer[0].TAM_FechaInicio__c){
                        periodoVenta = edoCtaByDealer[0].TAM_FechaEstadoCuenta__c;
                        system.debug('linea 499'+periodoVenta);
                    }
                    
                    
                    if(mapaEdoCtas.containsKey(inSol.TAM_CodigoDealer__c+'-'+periodoVenta) && mapInformacionVIN.containsKey(inSol.TAMVIN__c)){
                        estadoCuenta = mapaEdoCtas.get(inSol.TAM_CodigoDealer__c+'-'+periodoVenta);
                        detalleVIN  = mapInformacionVIN.get(inSol.TAMVIN__c);
                        TAM_DetalleEstadoCuenta__c lineaDetalle = new TAM_DetalleEstadoCuenta__c();
                        lineaDetalle.TAM_SolicitudExcepcion__c = inSol.id;
                        //Se verifica si existe esta VIN en un estado de cuenta . con estatus de "No pagado" de tipo 'Retail'
                        if(detalleVINEdoCta.containsKey(inSol.TAMVIN__c)){
                            TAM_DetalleEstadoCuenta__c detalleEdoCtaVIN = detalleVINEdoCta.get(inSol.TAMVIN__c);
                            lineaDetalle.TAM_IDExterno__c = detalleEdoCtaVIN.TAM_IDExterno__c;
                            //lineaDetalle.TAM_DetalleProvision__c = null;
                        }else{
                            lineaDetalle.TAM_IDExterno__c = estadoCuenta.Id+detalleVIN.TAM_VIN__c+recordIdRetail;
                        }
                        lineaDetalle.TAM_FechaCaducidad__c = date.today()+diasVigenciaInt;
                        lineaDetalle.TAM_CodigoDealer__c = estadoCuenta.TAM_CodigoDealer__c;
                        lineaDetalle.TAM_NombreDealer__c = estadoCuenta.TAM_NombreDealer__c;
                        lineaDetalle.TAM_VIN__c    =  inSol.TAMVIN__c;
                        lineaDetalle.TAM_Serie__c  =  detalleVIN.TAM_Serie__c;
                        lineaDetalle.TAM_Codigo_Producto__c = detalleVIN.ProductoCode__c;
                        lineaDetalle.TAM_AnioModelo__c     = detalleVIN.Year_Modelo__c;
                        lineaDetalle.TAM_EstadoCuenta__c   = estadoCuenta.Id;
                        lineaDetalle.TAM_Movimiento__c = 'Excepción';
                        lineaDetalle.TAM_FechaVenta__c = detalleVIN.Sale_Date__c;
                        lineaDetalle.TAM_NombrePropietario__c = detalleVIN.NombreCliente__c;
                        lineaDetalle.TAM_ApellidosPropietario__c = detalleVIN.Last_Name__c;
                        //Si es de Retail incentivo sin IVA
                        if(inSol.RecordTypeId == recordIdSolicitudRetail){
                            lineaDetalle.RecordTypeId = recordIdRetail;
                            decimal incentivoSinIVA = inSol.TAM_IncentivoTMEX__c/ 1.16;
                            lineaDetalle.TAM_IncentivoPropuestoDealer__c = incentivoSinIVA.setScale(2);
                            lineaDetalle.TAM_Monto_sin_IVA__c =  incentivoSinIVA.setScale(2);
                        }
                        //Si es de Auto Demo incentivo sin IVA 
                        if(inSol.RecordTypeId == recordIdSolicitudAutoDemo){
                            lineaDetalle.RecordTypeId = recordIdAutoDemo;
                            decimal incentivoSinIVA = inSol.TAM_IncentivoTMEX__c/ 1.16;
                            lineaDetalle.TAM_IncentivoPropuestoDealer__c = incentivoSinIVA.setScale(2);
                            lineaDetalle.TAM_Monto_sin_IVA__c =  incentivoSinIVA.setScale(2);
                        }
                        lineaDetalle.TAM_IntercambioEdoCta__c = false;
                        lineaDetalle.TAM_Estatus_Finanzas__c = 'Pendiente';
                        lineaDetalle.TAM_Fecha_Aprobacion_Final__c = inSol.TAM_Fecha_Autorizacion_Finanzas__c;
                        if(detalleVIN.Sale_Date__c != null){
                            lineaDetalle.TAM_Anio_Incentivo__c = String.valueOf(detalleVIN.Sale_Date__c.year());
                            lineaDetalle.TAM_Periodo__c = obtieneMesPeriodo(detalleVIN.Sale_Date__c.month());
                        }
                        detalleEdoCta.add(lineaDetalle);
                        edoDetalleEdoCta.put(estadoCuenta.Id+detalleVIN.TAM_VIN__c+recordIdRetail,lineaDetalle);
                    }
                }
            }  
        } 
        
        //Se Crean las Lineas de tipo VC pero se guardan con tipo de registro Retail
        for(TAM_SolicitudExpecionIncentivo__c inSol : listExcepciones){
            if(inSol.TAM_AprobacionFinanzas__c == 'Aprobado' && inSol.TAM_EstadoCuenta__c == false && (inSol.TAM_excepcionFlotillaRetail__c == true || inSol.recordtypeId == recordIdSolicitudVC)){
                if(mapInformacionVIN.containsKey(inSol.TAMVIN__c)){
                    detalleVIN  = mapInformacionVIN.get(inSol.TAMVIN__c);
                    List<TAM_EstadoCuenta__c> edoCtaByDealer = mapDealerEdoCta.get(inSol.TAM_CodigoDealer__c);
                    //Si la fecha de reporte es mayor
                    String periodoVenta;
                    if(inSol.TAM_SubmittedDate__c > edoCtaByDealer[0].TAM_FechaInicio__c){
                        periodoVenta = obtieneFechaTexto(inSol.TAM_SubmittedDate__c);
                    }
                    
                    //Si la fecha de reporte es menor
                    if(inSol.TAM_SubmittedDate__c <= edoCtaByDealer[0].TAM_FechaInicio__c){
                        periodoVenta = edoCtaByDealer[0].TAM_FechaEstadoCuenta__c;
                    }
                    
                    if(mapaEdoCtas.containsKey(inSol.TAM_CodigoDealer__c+'-'+periodoVenta) && mapInformacionVIN.containsKey(inSol.TAMVIN__c)){
                        estadoCuenta = mapaEdoCtas.get(inSol.TAM_CodigoDealer__c+'-'+periodoVenta);
                        detalleVIN  = mapInformacionVIN.get(inSol.TAMVIN__c);
                        TAM_DetalleEstadoCuenta__c lineaDetalle = new TAM_DetalleEstadoCuenta__c();
                        lineaDetalle.TAM_SolicitudExcepcion__c = inSol.id;
                        //Se verifica si existe esta VIN en un estado de cuenta . con estatus de "No pagado"
                        if(detalleVINEdoCta.containsKey(inSol.TAMVIN__c)){
                            TAM_DetalleEstadoCuenta__c detalleEdoCtaVIN = detalleVINEdoCta.get(inSol.TAMVIN__c);
                            lineaDetalle.TAM_IDExterno__c = detalleEdoCtaVIN.TAM_IDExterno__c;
                            //lineaDetalle.TAM_DetalleProvision__c = null;
                            lineaDetalle.TAM_IntercambioEdoCta__c = true;
                        }else{
                            lineaDetalle.TAM_IDExterno__c = estadoCuenta.Id+detalleVIN.TAM_VIN__c+recordIdRetail;
                        }
                        lineaDetalle.TAM_FechaCaducidad__c = date.today()+diasVigenciaInt;
                        lineaDetalle.TAM_CodigoDealer__c = estadoCuenta.TAM_CodigoDealer__c;
                        lineaDetalle.TAM_NombreDealer__c = estadoCuenta.TAM_NombreDealer__c;
                        lineaDetalle.TAM_VIN__c    =  inSol.TAMVIN__c;
                        lineaDetalle.TAM_Serie__c  =  detalleVIN.TAM_Serie__c;
                        lineaDetalle.TAM_Codigo_Producto__c = detalleVIN.ProductoCode__c;
                        lineaDetalle.TAM_AnioModelo__c     = detalleVIN.Year_Modelo__c;
                        lineaDetalle.TAM_EstadoCuenta__c   = estadoCuenta.Id;
                        lineaDetalle.RecordTypeId = recordIdRetail;
                        lineaDetalle.TAM_Movimiento__c = 'Excepción';
                        lineaDetalle.TAM_FechaVenta__c = detalleVIN.Sale_Date__c;
                        lineaDetalle.TAM_NombrePropietario__c = detalleVIN.NombreCliente__c;
                        lineaDetalle.TAM_ApellidosPropietario__c = detalleVIN.Last_Name__c;
                        system.debug('entro en la linea 483');
                        
                        decimal incentivoSinIVA = inSol.TAM_IncentivoTMEX__c/ 1.16;
                        lineaDetalle.TAM_Monto_sin_IVA__c =  incentivoSinIVA.setScale(2);
                        lineaDetalle.TAM_IncentivoPropuestoDealer__c = incentivoSinIVA.setScale(2);
                        lineaDetalle.TAM_Programa_Rango__c = inSol.TAM_RangoPrograma__c;
                        lineaDetalle.TAM_Fecha_Aprobacion_Final__c = inSol.TAM_Fecha_Autorizacion_Finanzas__c;
                        lineaDetalle.TAM_Estatus_Finanzas__c = 'Pendiente';
                        if(detalleVIN.Sale_Date__c != null){
                            lineaDetalle.TAM_Anio_Incentivo__c = String.valueOf(detalleVIN.Sale_Date__c.year());
                            lineaDetalle.TAM_Periodo__c = obtieneMesPeriodo(detalleVIN.Sale_Date__c.month());
                        }
                        
                        //Parte proporcional de TMEX
                        if(inSol.TAM_TotalIncentivoTMEXManual__c != null && inSol.TAM_TotalIncentivoDealerManual__c != null && inSol.TAM_IncentivoManual__c == true){
                            lineaDetalle.TAM_Porcentaje_TMEX__c =  inSol.TAM_TotalIncentivoTMEXManual__c;
                        }
                        if(inSol.TAM_PorcentajeTMEX__c != null && inSol.TAM_PorcentajeDealer__c != null  && inSol.TAM_IncentivoManual__c == false){
                            lineaDetalle.TAM_Porcentaje_TMEX__c =  inSol.TAM_PorcentajeTMEX__c;
                            
                        }
                        
                        //Porcentaje Total Manual
                        if(inSol.TAM_TotalIncentivoTMEXManual__c != null && inSol.TAM_TotalIncentivoDealerManual__c != null && inSol.TAM_IncentivoManual__c == true){
                            system.debug('entro a pocentaje manual');
                            lineaDetalle.TAM_Porcentaje__c =  inSol.TAM_TotalIncentivoTMEXManual__c + inSol.TAM_TotalIncentivoDealerManual__c;
                            decimal partePagarTMEX = (inSol.TAM_TotalIncentivoTMEXManual__c/100)*inSol.TAM_PrecioSolicitadoDealer__c;
                            lineaDetalle.TAM_Monto_sin_IVA__c = partePagarTMEX;
                        }
                        //Porcentaje Total Seleccionado
                        if(inSol.TAM_PorcentajeTMEX__c != null && inSol.TAM_PorcentajeDealer__c != null  && inSol.TAM_IncentivoManual__c == false){
                            //En Porcentaje
                            lineaDetalle.TAM_Porcentaje__c =  inSol.TAM_PorcentajeTMEX__c + inSol.TAM_PorcentajeDealer__c;
                            decimal partePagarTMEX = (inSol.TAM_PorcentajeTMEX__c/100)*inSol.TAM_PrecioSolicitadoDealer__c;
                            if(partePagarTMEX != 0){
                                system.debug('entro en la linea 512');
                                lineaDetalle.TAM_Monto_sin_IVA__c = partePagarTMEX;
                                lineaDetalle.TAM_IncentivoPropuestoDealer__c = partePagarTMEX;
                            }                  
                            //Política con cantidades en efectivo menos iva
                            if(inSol.TAM_IncentivoTMEX__c != 0 && partePagarTMEX == 0){
                                system.debug('entro a menos iva');
                                decimal iva = (16*inSol.TAM_IncentivoTMEX__c)/100;
                                lineaDetalle.TAM_IncentivoPropuestoDealer__c =  (inSol.TAM_IncentivoTMEX__c - iva);
                                lineaDetalle.TAM_Monto_sin_IVA__c =  (inSol.TAM_IncentivoTMEX__c - iva);
                                //Porcentaje proporcional de TMEX
                                //lineaDetalle.TAM_Porcentaje_TMEX__c = (inSol.TAM_IncentivoTMEX__c * 100)/inSol.TAM_PrecioSolicitadoDealer__c.setScale(2);
                                //lineaDetalle.TAM_Porcentaje__c = (lineaDetalle.TAM_IncentivoPropuestoDealer__c * 100)/inSol.TAM_PrecioSolicitadoDealer__c.setScale(2);
                            }
                        }
                        
                        detalleEdoCta.add(lineaDetalle);
                        edoDetalleEdoCta.put(estadoCuenta.Id+detalleVIN.TAM_VIN__c+recordIdRetail,lineaDetalle);
                    }
                } 
            }
            
        }
        
        
        if(!detalleEdoCta.isEmpty()){
            Schema.SObjectField idExterno = TAM_DetalleEstadoCuenta__c.Fields.TAM_IDExterno__c;
            try{
                system.debug('lista a insertar'+edoDetalleEdoCta);
                List<Database.UpsertResult> lcr = Database.upsert(edoDetalleEdoCta.values(),idExterno, false);
                Set<String> idInsertados = new Set<String> ();
                for (Database.UpsertResult objDtSvr : lcr){
                    if(objDtSvr.isSuccess())  
                        system.debug('Id Registros insertados de tipo Retail'+objDtSvr.getId());
                    idInsertados.add(objDtSvr.id);
                    if(!objDtSvr.isSuccess())
                        System.debug('Registros con error de tipo Retail:' + objDtSvr.getErrors()[0].getMessage());
                }      
                if(!idInsertados.isEmpty()){
                    actualizaFlagSolicitudExp(idInsertados); 
                }                    
            }catch(Exception e){
                system.debug('Error general al momento de insertar los registros de estado de cuenta de bono'+ e.getMessage());
            }
        }
    }
    
    //Se actualiza la bandera a nivel solicitud de excepción para indicar que ya fue creada en un estado de cuenta y no se puede volver a crear
    public static void actualizaFlagSolicitudExp(Set<String>listDetallesCreados){
        Set<String> listaVINES = new Set<String>();
        List<TAM_DetalleEstadoCuenta__c> detalleEdoCta  = new  List<TAM_DetalleEstadoCuenta__c> ();
        List<TAM_SolicitudExpecionIncentivo__c> solicitudesExcpRetail  = new List<TAM_SolicitudExpecionIncentivo__c>();
        List<TAM_SolicitudExpecionIncentivo__c> solicitudesExcUpd  = new List<TAM_SolicitudExpecionIncentivo__c>();
        if(!listDetallesCreados.isEmpty()){
            detalleEdoCta = [Select id,TAM_VIN__C From TAM_DetalleEstadoCuenta__c WHERE ID IN: listDetallesCreados];
            
        }
        
        Map<String,TAM_DetalleEstadoCuenta__c> VINDetalle = new Map<String,TAM_DetalleEstadoCuenta__c>();
        if(!detalleEdoCta.isEmpty()){
            for(TAM_DetalleEstadoCuenta__c detalle : detalleEdoCta){
                listaVINES.add(detalle.TAM_VIN__C);
                VINDetalle.put(detalle.TAM_VIN__C,detalle);
            }
            
        }
        
        if(!listaVINES.isEmpty()){
            solicitudesExcpRetail = [select id,TAMVIN__c,TAM_EstadoCuenta__c  FROM TAM_SolicitudExpecionIncentivo__c WHERE 
                                     TAMVIN__c IN:listaVINES  AND TAM_AprobacionFinanzas__c = 'Aprobado'
                                     AND TAM_EstadoCuenta__c = false];
            
        }
        
        if(!solicitudesExcpRetail.isEmpty()){
            for(TAM_SolicitudExpecionIncentivo__c inSol : solicitudesExcpRetail){
                if(VINDetalle.containsKey(inSol.TAMVIN__c)){
                    TAM_DetalleEstadoCuenta__c detalleEdo = VINDetalle.get(inSol.TAMVIN__c);
                    TAM_SolicitudExpecionIncentivo__c newItem = new TAM_SolicitudExpecionIncentivo__c();
                    newItem.TAM_DetalleEstadoCuenta__c = detalleEdo.Id;
                    newItem.id = inSol.id;
                    newItem.TAM_EstadoCuenta__c = true;
                    solicitudesExcUpd.add(newItem);
                }
                
            }
            
        }
        
        if(!solicitudesExcUpd.isEmpty()){       
            update solicitudesExcUpd;
        }
    }
    
    public  void generaEdoCtaVentaCorp (){
        List<TAM_SolicitudExpecionIncentivo__c> listExcepciones = new List<TAM_SolicitudExpecionIncentivo__c> ();
        Map<String,TAM_EstadoCuenta__c> mapaEdoCtas = new  Map<String,TAM_EstadoCuenta__c>(); 
        Map<String,Movimiento__c> mapInformacionVIN = new Map<String,Movimiento__c> ();
        Set<String> vinSolicitud = new Set<String> ();
        Set<String> codigoDealer = new Set<String>();
        List<Movimiento__c> movVIN = new List<Movimiento__C>(); 
        List<Date> fechaVenta = new List<Date>();
        List<TAM_EstadoCuenta__c> edoCtaLista = new List<TAM_EstadoCuenta__c>();
        List<TAM_EstadoCuenta__c> listadealerEstadoCuenta = new  List<TAM_EstadoCuenta__c>();
        List<TAM_DetalleEstadoCuenta__c> detalleEdoCta = new List<TAM_DetalleEstadoCuenta__c>();
        TAM_EstadoCuenta__c estadoCuenta = new TAM_EstadoCuenta__c (); 
        Movimiento__c  detalleVIN        = new Movimiento__c ();
        String edoCta;

        decimal diasVigencia = [Select TAM_DiasVigencia__c From TAM_DetalleEdoCta__c Limit 1].TAM_DiasVigencia__c;
        Integer diasVigenciaInt = diasVigencia.intValue();
        
        String recordIdSolicitudVC = Schema.SObjectType.TAM_SolicitudExpecionIncentivo__c.getRecordTypeInfosByDeveloperName().get('ExcepcionVentaCorporativa').getRecordTypeId();
        
        listExcepciones = [SELECT TAM_SolicitudExpecionIncentivo__c.TAM_SubmittedDate__c,TAM_Distribuidor__r.TAM_Gestor_Estado_Cuenta__c,CreatedDate,Email_DM__c,
                           Id,Incentivo_Correspondiente_TMEX__c,Name,Nombre_DM__c,RecordTypeId,TAMVIN__c,TAM_AnioModelo__c,TAM_AprobacionDM__c,TAM_AprobacionFinanzas__c,TAM_CodigoDealer__c,TAM_ComentarioDM__c,
                           TAM_ComentarioFinanzas__c,TAM_Comentario__c,TAM_Distribuidor__c,TAM_Email_DM__c,TAM_EstadoCuenta__c,TAM_FechaVigenciaCliente__c,TAM_Fecha_Autorizacion_DM__c,
                           TAM_Fecha_Autorizacion_Finanzas__c,TAM_FolioVentaCorporativa__c,TAM_IDExterno__c,TAM_IncCorrespCashTMEX__c,TAM_IncentivoCorrespondienteFecha__c,
                           TAM_IncentivoCorrespondienteRetail__c,TAM_IncentivoDealerPorcentaje__c,TAM_IncentivoDealer__c,TAM_IncentivoManual__c,TAM_IncentivoPropuestoPorcentaje__c,
                           TAM_IncentivoPropuesto__c,TAM_IncentivoTMEXPorcentaje__c,TAM_IncentivoTMEX__c,TAM_IncSeleccCashTMEX__c,TAM_listaVINES__c,TAM_Modelo__c,TAM_MontoIncentivoTMEXManual__c,
                           TAM_MontoIncentivoTMEXPolitica__c,TAM_MotivoCambioPrecio__c,TAM_MotivoSolicitudFlotilla__c,TAM_MotivoSolicitud__c,TAM_NombreCliente__c,TAM_NombreDealer__c,
                           TAM_NumeroVINES__c,TAM_PoliticaSeleccionadaFleet__c,TAM_PoliticaSeleccionadaRetail__c,TAM_PoliticaSeleccionada__c,TAM_PorcentajeDealer__c,TAM_PorcentajeTMEX__c,
                           TAM_PrecioSolicitadoDealer__c,TAM_PrecioVigente__c,TAM_RangoPrograma__c,TAM_Serie__c,TAM_TipoVenta__c,TAM_TotalIncentivoDealerManual__c,TAM_TotalIncentivoManual__c,
                           TAM_TotalIncentivoTMEXManual__c,TAM_VarianzaRetail__c,TAM_Varianza__c,TAM_VoBo_Aprobacio__c FROM TAM_SolicitudExpecionIncentivo__c WHERE (TAM_EstadoCuenta__c = false AND TAM_AprobacionFinanzas__c = 'Aprobado') AND
                           RecordTypeId =: recordIdSolicitudVC and TAM_excepcionFlotillaRetail__c = false limit 30];
        
        
        
        //Se verifica que la lista sea diferente de vacia 
        if(!listExcepciones.isEmpty()){
            for(TAM_SolicitudExpecionIncentivo__c inSol : listExcepciones){
                //Validación para comprobar que la excepción corresponde a un solicitud de VC , aprobada por finanzas y que no existe en otro edo cta
                if(inSol.TAM_AprobacionFinanzas__c == 'Aprobado' && inSol.TAM_EstadoCuenta__c == false && inSol.RecordTypeId == recordIdSolicitudVC){
                    vinSolicitud.add(inSol.TAMVIN__c);
                    codigoDealer.add(inSol.TAM_CodigoDealer__c);
                    fechaVenta.add(inSol.TAM_Fecha_Autorizacion_Finanzas__c);
                }
            }
        }
        
        if(!vinSolicitud.isEmpty()){
            movVIN = [Select id,name,Submitted_Date__c,ProductoCode__c,TAM_Serie__c,Serie__c ,TAM_VIN__c,Last_Name__c,NombreCliente__c,Sale_Date__c,
                      Trans_Type__c,Year_Modelo__c   From Movimiento__c WHERE TAM_VIN__c IN : vinSolicitud AND 
                      VIN__r.Ultimo_Movimiento__r.Trans_Type__c = 'RDR' ];  
            
        }
        
        
        if(!movVIN.isEmpty()){
            for(Movimiento__C mov : movVIN){
                //fechaVenta.add(mov.Submitted_Date__c.date());
                mapInformacionVIN.put(mov.TAM_VIN__c,mov);
            }
        }
        
        //Calcular fecha para estado de cuenta en base a la fecha de venta
        List<String> listaFechas = new List<String>();
        if(!fechaVenta.isEmpty()){
            listaFechas = obtieneFechaTextoList(fechaVenta);
        }
        
        
        //Se consultan los estados de cuenta por dealer que se encuentren abiertos ordenados por fecha
        List<TAM_EstadoCuenta__c> edoCtasDealer = new List<TAM_EstadoCuenta__c>();
        
        Map<String, List<TAM_EstadoCuenta__c>> mapDealerEdoCta = new Map<String, List<TAM_EstadoCuenta__c>>();
        
        
        for(TAM_EstadoCuenta__c edoCtaReg : [Select id,TAM_CodigoDealer__c,TAM_FechaInicio__c From TAM_EstadoCuenta__c
                                             WHERE TAM_CodigoDealer__c IN : codigoDealer and TAM_EstadoRegistro__c = 'Abierto'
                                             and TAM_FechaInicio__c != null
                                             order by TAM_FechaInicio__c desc]){
                                                 
                                                 if(!mapDealerEdoCta.containsKey(edoCtaReg.TAM_CodigoDealer__c)){    
                                                     mapDealerEdoCta.put(edoCtaReg.TAM_CodigoDealer__c, new TAM_EstadoCuenta__c[]{});
                                                 }
                                                 mapDealerEdoCta.get(edoCtaReg.TAM_CodigoDealer__c).add(edoCtaReg);
                                                 
                                             }
        
        
        
        system.debug('Mpa edo ctass'+mapDealerEdoCta);	
        
        
        
        
        //Se crea un estado de cuenta en base a la fecha de venta del VIN
        map<String,TAM_EstadoCuenta__c> edoCtaMap = new map<String,TAM_EstadoCuenta__c>();
        if(listaFechas.size()>0){
            for(TAM_SolicitudExpecionIncentivo__c inSol : listExcepciones){
                if(mapInformacionVIN.containsKey(inSol.TAMVIN__c)){
                    detalleVIN  = mapInformacionVIN.get(inSol.TAMVIN__c);
                    
                     List<TAM_EstadoCuenta__c> edoCtaByDealer = mapDealerEdoCta.get(inSol.TAM_CodigoDealer__c);
                	//Si fecha de reporte es mayor al ultimo estado de cuenta liberado --> la exepción se va al estado de cuenta del mes 
                	String fechaEdoCta;
                	system.debug('edo cta seleccionado'+edoCtaByDealer[0].TAM_FechaInicio__c);
                	if(inSol.TAM_SubmittedDate__c > edoCtaByDealer[0].TAM_FechaInicio__c){
                    	fechaEdoCta = obtieneFechaTexto(inSol.TAM_SubmittedDate__c);
                	}
                
                
                	//Si fecha de reporte es menor al último estado de cuenta liberado--> la excepción se va al último estado de cuenta liberado
                	if(inSol.TAM_SubmittedDate__c <= edoCtaByDealer[0].TAM_FechaInicio__c){
                    	fechaEdoCta = obtieneFechaTexto(edoCtaByDealer[0].TAM_FechaInicio__c);
                	}
                    
                    TAM_EstadoCuenta__c dealerEstadoCuenta = new TAM_EstadoCuenta__c();
                    dealerEstadoCuenta.TAM_CodigoDealer__c = inSol.TAM_CodigoDealer__c;
                    dealerEstadoCuenta.TAM_NombreDealer__c = inSol.TAM_NombreDealer__c;
                    dealerEstadoCuenta.TAM_FechaEstadoCuenta__c = fechaEdoCta;
                    dealerEstadoCuenta.Id_Externo__c      = inSol.TAM_CodigoDealer__c+'-'+fechaEdoCta;
                    dealerEstadoCuenta.name = inSol.TAM_CodigoDealer__c+'-'+fechaEdoCta;
                    if(inSol.TAM_Distribuidor__r.TAM_Gestor_Estado_Cuenta__c != null){
                        dealerEstadoCuenta.ownerId = inSol.TAM_Distribuidor__r.TAM_Gestor_Estado_Cuenta__c;
                    }
                    listadealerEstadoCuenta.add(dealerEstadoCuenta);
                    edoCtaMap.put(inSol.TAM_CodigoDealer__c+'-'+fechaEdoCta,dealerEstadoCuenta);
                }
            }
            //Si la lista es diferente de vacia se insertan los registros
            if(!listadealerEstadoCuenta.isEmpty()){
                Schema.SObjectField idExterno = TAM_EstadoCuenta__c.Fields.Id_Externo__c;
                try{
                    Database.UpsertResult [] cr = Database.upsert(edoCtaMap.values(),idExterno, false);
                    for (Database.UpsertResult objDtSvr : cr){
                        if(!objDtSvr.isSuccess())
                            System.debug('Regitros edos de cuenta con errores VC' + objDtSvr.getErrors()[0].getMessage());
                        
                        if(objDtSvr.isSuccess())
                            System.debug('Regitros edos de cuenta insertados VC' + objDtSvr.id);
                        
                    } 
                }catch(Exception e){
                    system.debug('Error en upsert de la lista listadealerEstadoCuenta'+e.getMessage());  
                } 
            } 
        }
        
        for(String mapValue : edoCtaMap.keySet()){
            mapaEdoCtas.put(mapValue,edoCtaMap.get(mapValue));
            
        }
        
        //Se obtienen detalles de estado de cuenta con los vines que se encuentran en su estado de cuenta
        List<TAM_DetalleEstadoCuenta__c> detalleEstadoCuenta = [Select id,TAM_DetalleProvision__r.TAM_CodigoDealer__c,TAM_VIN__c,TAM_IDExterno__c
                                                                From TAM_DetalleEstadoCuenta__c where recordtype.name = 'Flotilla' AND TAM_EstadoCuenta__c != null AND
                                                                TAM_Estatus_Finanzas__c != 'Pago Autorizado TMEX' AND TAM_VIN__C IN : vinSolicitud];
        
        system.debug('lista de exp VC'+detalleEstadoCuenta);
        Map<String,TAM_DetalleEstadoCuenta__c> detalleVINEdoCta = new Map<String,TAM_DetalleEstadoCuenta__c> ();
        
        if(!detalleEstadoCuenta.isEmpty()){
            for(TAM_DetalleEstadoCuenta__c dVIN : detalleEstadoCuenta){
                detalleVINEdoCta.put(dVIN.TAM_VIN__c,dVIN);
                
            }
        } 
        
        system.debug('Mapa del detalle'+detalleVINEdoCta);
        
        //Crear las lineas del estado de cuenta de tipo Excepciónes de tipo Excepción de venta corporativa
        map<String,TAM_DetalleEstadoCuenta__c> edoDetalleEdoCta = new map<String,TAM_DetalleEstadoCuenta__c>();
        String recordIdVC = Schema.SObjectType.TAM_DetalleEstadoCuenta__c.getRecordTypeInfosByDeveloperName().get('Flotilla').getRecordTypeId();
        for(TAM_SolicitudExpecionIncentivo__c inSol : listExcepciones){
            if(inSol.TAM_AprobacionFinanzas__c == 'Aprobado' && inSol.TAM_EstadoCuenta__c == false && listaFechas.size() > 0){
                if(mapInformacionVIN.containsKey(inSol.TAMVIN__c)){
                    detalleVIN  = mapInformacionVIN.get(inSol.TAMVIN__c);
                    List<TAM_EstadoCuenta__c> edoCtaByDealer = mapDealerEdoCta.get(inSol.TAM_CodigoDealer__c);
                    //Si la fecha de reporte es mayor
                    String periodoVenta;
                    if(inSol.TAM_SubmittedDate__c > edoCtaByDealer[0].TAM_FechaInicio__c){
                        periodoVenta = obtieneFechaTexto(inSol.TAM_SubmittedDate__c);
                    }
                    
                    //Si la fecha de reporte es menor
                    if(inSol.TAM_SubmittedDate__c <= edoCtaByDealer[0].TAM_FechaInicio__c){
                        periodoVenta = obtieneFechaTexto(edoCtaByDealer[0].TAM_FechaInicio__c);
                    }
                    if(mapaEdoCtas.containsKey(inSol.TAM_CodigoDealer__c+'-'+periodoVenta) && mapInformacionVIN.containsKey(inSol.TAMVIN__c)){
                        estadoCuenta = mapaEdoCtas.get(inSol.TAM_CodigoDealer__c+'-'+periodoVenta);
                        detalleVIN  = mapInformacionVIN.get(inSol.TAMVIN__c);
                        TAM_DetalleEstadoCuenta__c lineaDetalle = new TAM_DetalleEstadoCuenta__c();
                        lineaDetalle.TAM_SolicitudExcepcion__c = inSol.id;
                        //Se verifica si existe esta VIN en un estado de cuenta . con estatus de "No pagado"
                        if(detalleVINEdoCta.containsKey(inSol.TAMVIN__c)){
                            system.debug('existe una solicitud con el VIN'+inSol.TAMVIN__c );
                            TAM_DetalleEstadoCuenta__c detalleEdoCtaVIN = detalleVINEdoCta.get(inSol.TAMVIN__c);
                            system.debug('Id externo detalle existente'+detalleEdoCtaVIN.TAM_IDExterno__c);
                            lineaDetalle.TAM_IDExterno__c = detalleEdoCtaVIN.TAM_IDExterno__c;
                            //lineaDetalle.TAM_DetalleProvision__c = null;
                        }else{
                            system.debug('No existen detalles estado de cuenta');
                            lineaDetalle.TAM_IDExterno__c = estadoCuenta.Id+detalleVIN.TAM_VIN__c+recordIdVC;
                        }
                        lineaDetalle.TAM_FechaCaducidad__c = date.today()+diasVigenciaInt;
                        lineaDetalle.TAM_CodigoDealer__c = estadoCuenta.TAM_CodigoDealer__c;
                        lineaDetalle.TAM_NombreDealer__c = estadoCuenta.TAM_NombreDealer__c;
                        lineaDetalle.TAM_VIN__c    =  inSol.TAMVIN__c;
                        lineaDetalle.TAM_Serie__c  =  detalleVIN.TAM_Serie__c;
                        lineaDetalle.TAM_Codigo_Producto__c = detalleVIN.ProductoCode__c;
                        lineaDetalle.TAM_AnioModelo__c     = detalleVIN.Year_Modelo__c;
                        lineaDetalle.TAM_EstadoCuenta__c   = estadoCuenta.Id;
                        lineaDetalle.RecordTypeId = recordIdVC;
                        lineaDetalle.TAM_Movimiento__c = 'Excepción';
                        lineaDetalle.TAM_FechaVenta__c = detalleVIN.Sale_Date__c;
                        lineaDetalle.TAM_NombrePropietario__c = detalleVIN.NombreCliente__c;
                        lineaDetalle.TAM_ApellidosPropietario__c = detalleVIN.Last_Name__c;
                        lineaDetalle.TAM_IncentivoPropuestoDealer__c = inSol.TAM_IncentivoTMEX__c;
                        lineaDetalle.TAM_IntercambioEdoCta__c = false;
                        lineaDetalle.TAM_Monto_sin_IVA__c =  inSol.TAM_IncentivoTMEX__c;
                        lineaDetalle.TAM_Programa_Rango__c = inSol.TAM_RangoPrograma__c;
                        lineaDetalle.TAM_Fecha_Aprobacion_Final__c = inSol.TAM_Fecha_Autorizacion_Finanzas__c;
                        lineaDetalle.TAM_Estatus_Finanzas__c = 'Pendiente';
                        if(detalleVIN.Sale_Date__c != null){
                            lineaDetalle.TAM_Anio_Incentivo__c = String.valueOf(detalleVIN.Sale_Date__c.year());
                            lineaDetalle.TAM_Periodo__c = obtieneMesPeriodo(detalleVIN.Sale_Date__c.month());
                        }
                        
                        //Parte proporcional de TMEX
                        if(inSol.TAM_TotalIncentivoTMEXManual__c != null && inSol.TAM_TotalIncentivoDealerManual__c != null && inSol.TAM_IncentivoManual__c == true){
                            lineaDetalle.TAM_Porcentaje_TMEX__c =  inSol.TAM_TotalIncentivoTMEXManual__c;
                        }
                        if(inSol.TAM_PorcentajeTMEX__c != null && inSol.TAM_PorcentajeDealer__c != null  && inSol.TAM_IncentivoManual__c == false){
                            lineaDetalle.TAM_Porcentaje_TMEX__c =  inSol.TAM_PorcentajeTMEX__c;
                            
                        }
                        
                        //Porcentaje Total Manual
                        if(inSol.TAM_TotalIncentivoTMEXManual__c != null && inSol.TAM_TotalIncentivoDealerManual__c != null && inSol.TAM_IncentivoManual__c == true){
                            lineaDetalle.TAM_Porcentaje__c =  inSol.TAM_TotalIncentivoTMEXManual__c + inSol.TAM_TotalIncentivoDealerManual__c;
                            decimal partePagarTMEX = (inSol.TAM_TotalIncentivoTMEXManual__c/100)*inSol.TAM_PrecioSolicitadoDealer__c;
                            decimal IVA = (16*partePagarTMEX)/100;
                            decimal parteTMEXSinIVA = (inSol.TAM_PrecioSolicitadoDealer__c * inSol.TAM_TotalIncentivoTMEXManual__c)/116;
                            lineaDetalle.TAM_Monto_sin_IVA__c = parteTMEXSinIVA;
                        }
                        //Porcentaje Total Seleccionado
                        if(inSol.TAM_PorcentajeTMEX__c != null && inSol.TAM_PorcentajeDealer__c != null  && inSol.TAM_IncentivoManual__c == false){
                            //En Porcentaje
                            lineaDetalle.TAM_Porcentaje__c =  inSol.TAM_PorcentajeTMEX__c + inSol.TAM_PorcentajeDealer__c;
                            decimal partePagarTMEX = (inSol.TAM_PorcentajeTMEX__c/100)*inSol.TAM_PrecioSolicitadoDealer__c;
                            decimal IVADetalle = (16 * partePagarTMEX)/100;
                            decimal partePagarTMEXSinIva = (partePagarTMEX - IVADetalle);
                            decimal parteTMEXSinIVA = (inSol.TAM_PrecioSolicitadoDealer__c * inSol.TAM_PorcentajeTMEX__c)/116;
                            if(partePagarTMEX != 0){
                                lineaDetalle.TAM_Monto_sin_IVA__c = parteTMEXSinIVA;
                                lineaDetalle.TAM_IncentivoPropuestoDealer__c = parteTMEXSinIVA;
                            }                  
                            //Política con cantidades en efectivo
                            if(inSol.TAM_IncentivoTMEX__c != 0 && partePagarTMEX == 0){
                                decimal iva = (16*inSol.TAM_IncentivoTMEX__c)/100;
                                lineaDetalle.TAM_IncentivoPropuestoDealer__c =  (inSol.TAM_IncentivoTMEX__c - iva);
                                lineaDetalle.TAM_Monto_sin_IVA__c =  (inSol.TAM_IncentivoTMEX__c - iva);
                                //Porcentaje proporcional de TMEX
                                //lineaDetalle.TAM_Porcentaje_TMEX__c = (inSol.TAM_IncentivoTMEX__c * 100)/inSol.TAM_PrecioSolicitadoDealer__c.setScale(2);
                                //lineaDetalle.TAM_Porcentaje__c = (lineaDetalle.TAM_IncentivoPropuestoDealer__c * 100)/inSol.TAM_PrecioSolicitadoDealer__c.setScale(2);
                            }
                        }
                        
                        detalleEdoCta.add(lineaDetalle);
                        
                    }
                } 
            }
            
        }
        
        if(!detalleEdoCta.isEmpty()){
            Schema.SObjectField idExterno = TAM_DetalleEstadoCuenta__c.Fields.TAM_IDExterno__c;
            try{
                List<Database.UpsertResult> lcr = Database.upsert(detalleEdoCta,idExterno, false);
                Set<String> idInsertados = new Set<String> ();
                for (Database.UpsertResult objDtSvr : lcr){
                    if(objDtSvr.isSuccess())  
                        system.debug('Id Registros insertados de VC'+objDtSvr.id);
                    idInsertados.add(objDtSvr.id);
                    if(!objDtSvr.isSuccess())
                        System.debug('Registros con error de VC:' + objDtSvr.getErrors()[0].getMessage());
                }      
                actualizaFlagSolicitudExp(idInsertados); 
            }catch(Exception e){
                system.debug('Error general al momento de insertar los registros de estado de cuenta de bono'+ e.getMessage());
            }
        } 
    }
    
    public static List<String> obtieneFechaTextoList(List<Date> fechasIn){
        Map<Integer,String> mapFecha = new Map<Integer,String>();
        List<String> fechaTextoLista = new List<String> ();
        
        mapFecha.put(1,'ENERO');
        mapFecha.put(2,'FEBRERO');
        mapFecha.put(3,'MARZO');
        mapFecha.put(4,'ABRIL');
        mapFecha.put(5,'MAYO');
        mapFecha.put(6,'JUNIO');
        mapFecha.put(7,'JULIO');
        mapFecha.put(8,'AGOSTO');
        mapFecha.put(9,'SEPTIEMBRE');
        mapFecha.put(10,'OCTUBRE');
        mapFecha.put(11,'NOVIEMBRE');
        mapFecha.put(12,'DICIEMBRE');
        
        if(!fechasIn.isEmpty()){
            for(Date i : fechasIn){
                Date fecha = i;
                Integer mes = i.month();
                Integer anio = i.year();
                String  fechaTexto = mapFecha.get(mes)+' '+anio;
                fechaTextoLista.add(fechaTexto);
            }
        }
        
        return  fechaTextoLista;
    }
    
    public static String obtieneFechaTexto(Date fechaIn){
        Map<Integer,String> mapFecha = new Map<Integer,String>();
        String fechaTexto;
        
        Date fecha = fechaIn;
        Integer mes = fecha.month();
        Integer anio = fecha.year();
        
        mapFecha.put(1,'ENERO');
        mapFecha.put(2,'FEBRERO');
        mapFecha.put(3,'MARZO');
        mapFecha.put(4,'ABRIL');
        mapFecha.put(5,'MAYO');
        mapFecha.put(6,'JUNIO');
        mapFecha.put(7,'JULIO');
        mapFecha.put(8,'AGOSTO');
        mapFecha.put(9,'SEPTIEMBRE');
        mapFecha.put(10,'OCTUBRE');
        mapFecha.put(11,'NOVIEMBRE');
        mapFecha.put(12,'DICIEMBRE');
        
        fechaTexto = mapFecha.get(mes)+' '+anio;
        
        return fechaTexto;
        
    }
    
    public static String obtieneMesPeriodo(Integer Mes){
        String mesNombre;
        Map<Integer,String> mapFecha = new Map<Integer,String>();
        mapFecha.put(1,'ENERO');
        mapFecha.put(2,'FEBRERO');
        mapFecha.put(3,'MARZO');
        mapFecha.put(4,'ABRIL');
        mapFecha.put(5,'MAYO');
        mapFecha.put(6,'JUNIO');
        mapFecha.put(7,'JULIO');
        mapFecha.put(8,'AGOSTO');
        mapFecha.put(9,'SEPTIEMBRE');
        mapFecha.put(10,'OCTUBRE');
        mapFecha.put(11,'NOVIEMBRE');
        mapFecha.put(12,'DICIEMBRE');
        
        if(mapFecha.containsKey(Mes)){
            mesNombre = mapFecha.get(Mes);
        }
        
        
        return mesNombre;
    }
    
    
    
}